﻿using System;
using System.Data;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 헬퍼
        /// </summary>
        private FocusRowHelper helper;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.gridView.OptionsBehavior.Editable = false;

            this.helper = new FocusRowHelper(this.gridView);

            this.Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 폼 닫을 경우 처리하기 - OnFormClosing(e)

        /// <summary>
        /// 폼 닫을 경우 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            base.OnFormClosing(e);

            this.helper.Deactivate();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.gridControl.DataSource = GetSampleData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 샘플 데이터 구하기 - GetSampleData()

        /// <summary>
        /// 샘플 데이터 구하기
        /// </summary>
        /// <returns>샘플 데이터</returns>
        private DataTable GetSampleData()
        {
            DataTable table = new DataTable();

            table.Columns.Add("ID"  , typeof(int   ));
            table.Columns.Add("Name", typeof(string));

            for(int i = 1; i <= 100; i++)
            {
                table.Rows.Add(new object[] { i, "항목 " + i.ToString() });
            }

            table.AcceptChanges();

            return table;
        }

        #endregion
    }
}